<template>
  <q-layout view="lHh Lpr lFf" id="layout">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
        />

        <q-toolbar-title> Ku sobie </q-toolbar-title>
        <div style="position: relative; left: -100px; font-size: 21px">
          Portal randkowy
        </div>
        <div v-if="!user.uuid" class="buttons-wrapper">
          <q-btn
            @click="toggleLoginDialog"
            class="q-btn-login-register-logout"
            color="white"
            text-color="black"
            label="Loguj"
          />
          <q-btn
            @click="toggleRegisterDialog"
            class="q-btn-login-register-logout"
            color="white"
            text-color="black"
            label="Rejestruj się"
          />
        </div>
        <PanelComponent
          v-if="user.uuid"
          @click="
            () => {
              router.push({ path: 'profilePage' });
            }
          "
          style="margin-right: 20px"
          :nick="user.nick"
          :image="user.photos.profile"
        />
        <div v-if="user.uuid" class="buttons-wrapper">
          <q-btn
            @click="toggleLogoutDialog"
            class="q-btn-login-register-logout"
            color="white"
            text-color="black"
            label="Wyloguj"
          />
        </div>
      </q-toolbar>
    </q-header>
    <LoginDialog :loginDialog="loginDialog" :toggleLogin="toggleLoginDialog" />
    <RegisterDialog
      :registerDialog="registerDialog"
      :toggleRegister="toggleRegisterDialog"
    />
    <q-drawer v-model="leftDrawerOpen" show-if-above bordered>
      <q-list>
        <q-item-label header> Menu </q-item-label>

        <EssentialLink
          @click="
            () => {
              if (!link.title.match('/Historie/')) {
                socketStore.selectPerson('');
              }
            }
          "
          v-for="link in linksList"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script setup lang="ts">
import { ref, watch, reactive } from 'vue';
import { useRouter } from 'vue-router';
import { useQuasar } from 'quasar';

import eventBus from '../eventBus';
import { useUserStore } from '../stores/user';
import { useSocketStore } from '../stores/socket';
import { storeToRefs } from 'pinia';

import { api } from '../boot/axios';
import EssentialLink, {
  EssentialLinkProps,
} from 'components/EssentialLink.vue';
import LoginDialog from 'components/LoginDialog.vue';
import RegisterDialog from 'components/RegisterDialog.vue';
import PanelComponent from 'src/components/PanelComponent.vue';

defineOptions({
  name: 'MainLayout',
});

const router = useRouter();
const $q = useQuasar();
const userStore = useUserStore();
const socketStore = useSocketStore();
// const { user } = userStore;
const { selectedPerson } = socketStore;
const { user } = storeToRefs(userStore);
const linksList = ref<EssentialLinkProps[]>([
  {
    title: 'Strona główna',
    icon: 'fa-home',
    link: '/#/',
  },
  {
    title: 'Historie',
    icon: 'fa-solid fa-heart',
    link: '/#/stories',
  },
  {
    title: 'Pisali o nas',
    icon: 'fa-regular fa-heart',
    link: '/#/about',
  },
]);

watch(
  () => user,
  (newUser) => {
    if (newUser.value.uuid !== '') {
      linksList.value = [
        {
          title: 'Szukaj miłości',
          icon: 'fa-regular fa-heart',
          link: '/#/search',
        },
        {
          title: 'Wiadomości',
          icon: 'fa-regular fa-comments',
          link: '/#/communicatorPage',
        },
        {
          title: 'Dopasowania',
          icon: 'fa-regular fa-heart',
          link: '/#/matchingPage',
        },
        {
          title: 'Odwiedziny',
          icon: 'fa-regular fa-heart',
          link: '/#/visitsPage',
        },
      ];
    }
    state.value = Math.random();
  },
  { deep: true }
);

const leftDrawerOpen = ref<boolean>(false);
const loginDialog = ref<boolean>(false);
const registerDialog = ref<boolean>(false);
const nrOfMessages = ref<number>(0);

const state = reactive({
  value: 0,
});

eventBus.on('unreceivedMessages', (data) => {
  nrOfMessages.value = 0;
  for (let i = 0, max = socketStore.unreadMessages.length; i < max; i++) {
    nrOfMessages.value += socketStore.unreadMessages[i].number || 0;
  }
  for (let el in data) {
    if (el === selectedPerson) {
      continue;
    }
    nrOfMessages.value += data[el].length;
  }
  linksList.value[1].title = `Wiadomości (${nrOfMessages.value})`;
});

function toggleLeftDrawer() {
  leftDrawerOpen.value = !leftDrawerOpen.value;
}

function toggleLoginDialog() {
  loginDialog.value = !loginDialog.value;
}

function toggleRegisterDialog() {
  registerDialog.value = !registerDialog.value;
}

function toggleLogoutDialog() {
  api.post('/user/logout/', { uuid: user.value.uuid }).then(({ data }) => {
    if (data.status === 'OK') {
      userStore.wanishUser();
      $q.notify({
        message: 'Zostałeś wylogowany',
        html: true,
      });

      setTimeout(() => {
        router.push({ path: '/' });
      }, 3000);
    }
  });
}
</script>

<style lang="scss">
.q-btn-login-register-logout {
  font-size: 19px;
  transform: translateX(-24px);
}
q-layout {
  color: rgba(0, 0, 0, 0.87);

  .q-layout__section--marginal {
    background: rgba(200, 200, 200, 0.9) !important;
  }
}
.q-toolbar__title {
  font-size: 30px;
  width: 200px;
}
.buttons-wrapper {
  width: 10%;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: center;
  button {
    border-radius: 0px;
    margin: 5px;
    background: rgba(100, 100, 100, 0) !important;
  }
}
</style>
